use crate::prelude::*;
use sea_orm::{Database, DatabaseConnection};
use thiserror::Error;

#[derive(Clone)]
pub struct State {
    db: DatabaseConnection,
}

impl State {
    pub async fn try_new(database_connection_string: &str) -> Result<Self, NewStateError> {
        Ok(Self {
            db: Database::connect(database_connection_string).await?,
        })
    }
}

#[derive(Error, Debug)]
pub enum NewStateError {
    #[error("database error: {0}")]
    Database(#[from] sea_orm::DbErr),
}
